import java.util.Arrays;

float gridSize=8.00;
float size;
boolean display=false;
boolean[] save;
boolean saveExists=false;
boolean displayHelp=true;
float coinFlip;

String help="A-Z: Draw a pattern\nSPACE: Change colour\nLEFT/RIGHT: Change size\n\nENTER: Generate a random pattern\n(can be then modified with A-Z)\n\nCONTROL/CMD: Save current pattern\nTAB: Load saved pattern\n\nBACKSPACE: Start over";


int h1;
int s1;
int v1;

int h1s;
int s1s;
int v1s;

int hbg;
int sbg;
int vbg;

int hbgs;
int sbgs;
int vbgs;

Tile[] tiles;

int[] keyA={  0, 0, 0, 0, 0, 0, 1, 0, 
              0, 1, 0, 0, 0, 1, 1, 0, 
              0, 1, 1, 0, 0, 0, 1, 0, 
              0, 1, 0, 0, 0, 1, 1, 0,
              0, 1, 1, 0, 0, 0, 1, 0, 
              0, 1, 0, 0, 0, 1, 1, 0, 
              0, 1, 1, 0, 0, 0, 1, 0, 
              0, 1, 0, 0, 0, 0, 0, 0,};
           
int[] keyB={  0, 0, 0, 0, 0, 0, 1, 0, 
              0, 1, 0, 0, 0, 0, 0, 0, 
              0, 0, 0, 0, 0, 0, 1, 0, 
              0, 1, 0, 0, 1, 1, 1, 1,
              1, 1, 1, 1, 0, 0, 1, 0, 
              0, 1, 0, 0, 0, 0, 0, 0, 
              0, 0, 0, 0, 0, 0, 1, 0, 
              0, 1, 0, 0, 0, 0, 0, 0,};
              
int[] keyC={  0, 0, 0, 0, 0, 0, 0, 0, 
              0, 0, 0, 0, 0, 0, 0, 0, 
              0, 0, 0, 0, 0, 0, 0, 0, 
              0, 0, 0, 0, 0, 0, 0, 0,
              0, 0, 0, 0, 0, 1, 1, 1, 
              1, 1, 1, 0, 0, 1, 1, 0, 
              0, 1, 1, 0, 0, 0, 1, 0, 
              0, 1, 0, 0, 0, 0, 0, 0,};
              
int[] keyD={  0, 0, 0, 0, 0, 0, 1, 0, 
              0, 1, 0, 0, 0, 1, 1, 0, 
              0, 1, 1, 0, 0, 1, 1, 1, 
              1, 1, 1, 0, 1, 1, 1, 1,
              0, 0, 0, 0, 0, 0, 0, 0, 
              0, 0, 0, 0, 0, 0, 0, 0, 
              0, 0, 0, 0, 0, 0, 0, 0, 
              0, 0, 0, 0, 0, 0, 0, 0,};
              
int[] keyE={  0, 0, 0, 0, 0, 0, 0, 0, 
              0, 0, 0, 0, 0, 0, 0, 0, 
              1, 1, 1, 1, 1, 1, 1, 1, 
              1, 1, 1, 1, 1, 1, 1, 1,
              1, 1, 1, 1, 1, 1, 1, 1, 
              1, 1, 1, 1, 1, 1, 1, 1, 
              0, 0, 0, 0, 0, 0, 0, 0, 
              0, 0, 0, 0, 0, 0, 0, 0,};

int[] keyF={  0, 0, 0, 0, 0, 0, 0, 0, 
              0, 0, 0, 0, 0, 0, 0, 0, 
              1, 1, 1, 1, 1, 1, 0, 1, 
              1, 0, 1, 1, 1, 0, 0, 1,
              1, 0, 0, 1, 1, 1, 0, 1, 
              1, 0, 1, 1, 1, 1, 1, 1, 
              0, 0, 0, 0, 0, 0, 0, 0, 
              0, 0, 0, 0, 0, 0, 0, 0,};
              
int[] keyG={  0, 1, 1, 0, 0, 1, 1, 0, 
              0, 1, 1, 0, 0, 1, 1, 0, 
              1, 0, 0, 1, 1, 0, 0, 1, 
              1, 0, 0, 1, 1, 0, 0, 1,
              0, 0, 0, 0, 0, 0, 0, 0, 
              0, 0, 0, 0, 0, 0, 0, 0, 
              0, 0, 0, 0, 0, 0, 0, 0, 
              0, 0, 0, 0, 0, 0, 0, 0,};              

int[] keyH={  1, 0, 0, 1, 1, 1, 0, 1, 
              1, 0, 1, 1, 1, 0, 0, 1, 
              1, 0, 0, 1, 0, 0, 0, 0, 
              0, 0, 0, 0, 0, 0, 0, 0,
              0, 0, 0, 0, 0, 0, 0, 0, 
              0, 0, 0, 0, 1, 0, 0, 1, 
              1, 0, 0, 1, 1, 1, 0, 1, 
              1, 0, 1, 1, 1, 0, 0, 1,};

int[] keyI={  0, 1, 1, 0, 0, 1, 1, 0, 
              0, 1, 1, 0, 0, 1, 1, 0, 
              0, 1, 1, 0, 0, 1, 1, 0, 
              0, 1, 1, 0, 0, 1, 1, 0,
              0, 1, 1, 0, 0, 1, 1, 0, 
              0, 1, 1, 0, 0, 1, 1, 0, 
              0, 1, 1, 0, 0, 1, 1, 0, 
              0, 1, 1, 0, 0, 1, 1, 0,};

int[] keyJ={  0, 0, 0, 0, 0, 0, 0, 0, 
              0, 0, 0, 0, 0, 0, 0, 0,
              0, 0, 0, 0, 0, 0, 0, 0,
              0, 0, 0, 0, 0, 0, 0, 0,
              0, 0, 0, 0, 1, 0, 1, 0,
              0, 1, 0, 1, 1, 1, 1, 1,
              1, 1, 1, 1, 0, 1, 0, 1,
              1, 0, 1, 0, 0, 0, 0, 0,};

int[] keyK={  0, 0, 0, 0, 0, 0, 1, 0, 
              0, 1, 0, 0, 0, 1, 1, 0,
              0, 1, 1, 0, 0, 1, 0, 1, 
              1, 0, 1, 0, 1, 0, 0, 1,
              1, 0, 0, 1, 0, 1, 0, 1, 
              1, 0, 1, 0, 0, 1, 1, 0,
              0, 1, 1, 0, 0, 0, 1, 0, 
              0, 1, 0, 0, 0, 0, 0, 0,};

int[] keyL={  1, 1, 1, 1, 1, 1, 0, 1, 
              1, 0, 1, 1, 1, 0, 0, 1,
              1, 0, 0, 1, 0, 0, 0, 0, 
              0, 0, 0, 0, 0, 0, 0, 0,
              0, 0, 0, 0, 0, 0, 0, 0, 
              0, 0, 0, 0, 1, 0, 0, 1,
              1, 0, 0, 1, 1, 1, 0, 1, 
              1, 0, 1, 1, 1, 1, 1, 1,};

  
int[] keyM={  0, 0, 0, 0, 0, 0, 0, 0, 
              0, 0, 0, 0, 0, 0, 0, 0,
              0, 0, 0, 0, 0, 0, 1, 0, 
              0, 1, 0, 0, 0, 1, 1, 0,
              0, 1, 1, 0, 0, 1, 1, 1, 
              1, 1, 1, 0, 1, 1, 1, 1,
              0, 1, 1, 0, 0, 1, 1, 1, 
              1, 1, 1, 0, 1, 1, 1, 1,};

int[] keyN={  1, 0, 0, 1, 1, 1, 0, 1, 
              1, 0, 1, 1, 1, 0, 0, 1,
              1, 0, 0, 1, 1, 0, 0, 0, 
              0, 0, 0, 1, 0, 0, 0, 0,
              0, 0, 0, 0, 1, 0, 0, 0, 
              0, 0, 0, 1, 1, 0, 0, 1,
              1, 0, 0, 1, 1, 0, 0, 0, 
              0, 0, 0, 1, 1, 0, 0, 1,};

int[] keyO={  0, 0, 0, 0, 0, 1, 0, 0, 
              0, 0, 1, 0, 0, 1, 1, 0,
              0, 1, 1, 0, 0, 1, 1, 0, 
              0, 1, 1, 0, 0, 1, 1, 0,
              0, 1, 1, 0, 0, 1, 1, 0, 
              0, 1, 1, 0, 0, 1, 1, 0,
              0, 1, 1, 0, 0, 1, 0, 0, 
              0, 0, 1, 0, 0, 0, 0, 0,};

int[] keyP={  1, 1, 1, 1, 1, 1, 0, 1, 
              1, 0, 1, 1, 1, 0, 0, 1,
              1, 0, 0, 1, 1, 1, 0, 1, 
              1, 0, 1, 1, 0, 1, 1, 0,
              0, 1, 1, 0, 1, 0, 1, 0, 
              0, 1, 0, 1, 1, 0, 0, 1,
              1, 0, 0, 1, 1, 1, 0, 1, 
              1, 0, 1, 1, 1, 1, 1, 1,};

int[] keyQ={  1, 1, 1, 1, 1, 1, 0, 1, 
              1, 0, 1, 1, 1, 0, 0, 1,
              1, 0, 0, 1, 1, 0, 0, 0, 
              0, 0, 0, 1, 1, 0, 0, 1,
              1, 0, 0, 1, 1, 0, 0, 0, 
              0, 0, 0, 1, 0, 0, 0, 0,
              0, 0, 0, 0, 1, 0, 1, 0, 
              0, 1, 0, 1, 1, 1, 1, 1,};

int[] keyR={  1, 1, 1, 1, 1, 0, 1, 1, 
              1, 1, 0, 1, 1, 0, 0, 1,
              1, 0, 0, 1, 1, 0, 0, 1, 
              1, 0, 0, 1, 1, 0, 0, 1,
              1, 0, 0, 1, 1, 0, 1, 0, 
              0, 1, 0, 1, 1, 0, 0, 1,
              1, 0, 0, 1, 1, 1, 0, 1, 
              1, 0, 1, 1, 1, 1, 1, 1,};
              
int[] keyS={  0, 1, 1, 0, 0, 0, 1, 0, 
              0, 1, 0, 0, 0, 0, 0, 0,
              0, 0, 0, 0, 1, 0, 1, 0, 
              0, 1, 0, 1, 1, 1, 1, 1,
              1, 1, 1, 1, 1, 1, 1, 1, 
              1, 1, 1, 1, 1, 1, 1, 1,
              1, 1, 1, 1, 1, 1, 1, 1, 
              1, 1, 1, 1, 1, 1, 1, 1,};

int[] keyT={  1, 1, 1, 1, 1, 1, 1, 1, 
              1, 1, 1, 1, 1, 1, 1, 1,
              0, 0, 0, 0, 1, 0, 0, 0, 
              0, 0, 0, 1, 1, 0, 0, 1,
              1, 0, 0, 1, 1, 0, 0, 1, 
              1, 0, 0, 1, 1, 0, 0, 1,
              1, 0, 0, 1, 1, 0, 0, 1, 
              1, 0, 0, 1, 1, 0, 0, 1,};

int[] keyU={  1, 1, 1, 1, 1, 1, 1, 1, 
              1, 1, 1, 1, 1, 1, 1, 1,
              1, 1, 1, 1, 1, 0, 1, 1, 
              1, 1, 0, 1, 1, 0, 0, 1,
              1, 0, 0, 1, 1, 0, 0, 1, 
              1, 0, 0, 1, 1, 0, 0, 1,
              1, 0, 0, 1, 1, 1, 0, 1, 
              1, 0, 1, 1, 1, 1, 1, 1,};

int[] keyV={  1, 1, 1, 1, 1, 1, 1, 1, 
              1, 1, 1, 1, 1, 1, 1, 1,
              1, 1, 1, 1, 1, 0, 1, 0, 
              0, 1, 0, 1, 0, 0, 0, 0,
              0, 0, 0, 0, 1, 0, 0, 0, 
              0, 0, 0, 1, 1, 0, 0, 1,
              1, 0, 0, 1, 1, 1, 0, 1, 
              1, 0, 1, 1, 1, 1, 1, 1,};

int[] keyW={  0, 1, 1, 0, 0, 0, 1, 0, 
              0, 1, 0, 0, 0, 0, 0, 0,
              1, 1, 1, 1, 1, 0, 1, 0, 
              0, 1, 0, 1, 0, 0, 0, 0,
              1, 0, 0, 1, 1, 0, 1, 0, 
              0, 1, 0, 1, 1, 0, 0, 1,
              1, 0, 0, 1, 1, 1, 0, 1, 
              1, 0, 1, 1, 1, 1, 1, 1,};

int[] keyX={  1, 1, 1, 1, 1, 1, 1, 1, 
              1, 1, 1, 1, 1, 1, 1, 1,
              1, 1, 1, 1, 1, 0, 1, 1, 
              1, 1, 0, 1, 1, 0, 0, 1,
              1, 0, 0, 1, 1, 0, 1, 1, 
              1, 1, 0, 1, 1, 1, 1, 1,
              1, 1, 1, 1, 1, 1, 1, 1, 
              1, 1, 1, 1, 1, 1, 1, 1,};

int[] keyY={  1, 1, 1, 1, 1, 1, 1, 1, 
              1, 1, 1, 1, 1, 1, 1, 1,
              0, 0, 0, 0, 1, 0, 0, 0, 
              0, 0, 0, 1, 1, 0, 0, 1,
              1, 0, 0, 1, 1, 1, 0, 1, 
              1, 0, 1, 1, 1, 0, 0, 1,
              1, 0, 0, 1, 1, 1, 0, 1, 
              1, 0, 1, 1, 1, 1, 1, 1,};

int[] keyZ={  1, 1, 1, 1, 1, 1, 1, 1, 
              1, 1, 1, 1, 1, 0, 0, 1,
              1, 0, 0, 1, 1, 0, 0, 0, 
              0, 0, 0, 1, 1, 1, 1, 1,
              1, 1, 1, 1, 1, 0, 0, 0, 
              0, 0, 0, 1, 1, 0, 0, 1,
              1, 0, 0, 1, 1, 1, 1, 1, 
              1, 1, 1, 1, 1, 1, 1, 1,};

int[][] sym=  {
              {0 ,0, 0, 0},
              {0 ,0, 0, 0},
              {0 ,0, 0, 0},
              {0 ,0, 0, 0},
              {0 ,0, 0, 0},
              {0 ,0, 0, 0},
              {0 ,0, 0, 0},
              {0 ,0, 0, 0},
              {0 ,0, 0, 0},
              {0 ,0, 0, 0},
              {0 ,0, 0, 0},
              {0 ,0, 0, 0},
              {0 ,0, 0, 0},
              {0 ,0, 0, 0},
              {0 ,0, 0, 0},
              {0 ,0, 0, 0},
              };


void setup(){
  
  
  save = new boolean[64];
  
  tiles = new Tile[64];
  
  tiles[0] = new Tile(0,0,2,0,1,1,display);
  tiles[1] = new Tile(2,0,4,0,3,1,display);
  tiles[2] = new Tile(4,0,6,0,5,1,display);
  tiles[3] = new Tile(6,0,8,0,7,1,display);
  
  tiles[4] = new Tile(0,0,1,1,0,2,display);
  tiles[5] = new Tile(2,0,3,1,2,2,display);
  tiles[6] = new Tile(4,0,5,1,4,2,display);
  tiles[7] = new Tile(6,0,7,1,6,2,display);
  
  tiles[8] = new Tile(2,0,2,2,1,1,display);
  tiles[9] = new Tile(4,0,4,2,3,1,display);
  tiles[10] =new Tile(6,0,6,2,5,1,display);
  tiles[11] =new Tile(8,0,8,2,7,1,display);
  
  tiles[12] =new Tile(0,2,2,2,1,1,display);
  tiles[13] =new Tile(2,2,4,2,3,1,display);
  tiles[14] =new Tile(4,2,6,2,5,1,display);
  tiles[15] =new Tile(6,2,8,2,7,1,display);
  
  
  
  tiles[16] =new Tile(0,2,2,2,1,3,display);
  tiles[17] =new Tile(2,2,4,2,3,3,display);
  tiles[18] =new Tile(4,2,6,2,5,3,display);
  tiles[19] =new Tile(6,2,8,2,7,3,display);
  
  tiles[20] =new Tile(0,2,1,3,0,4,display);
  tiles[21] =new Tile(2,2,3,3,2,4,display);
  tiles[22] =new Tile(4,2,5,3,4,4,display);
  tiles[23] =new Tile(6,2,7,3,6,4,display);
  
  tiles[24] =new Tile(2,2,2,4,1,3,display);
  tiles[25] =new Tile(4,2,4,4,3,3,display);
  tiles[26] =new Tile(6,2,6,4,5,3,display);
  tiles[27] =new Tile(8,2,8,4,7,3,display);
  
  tiles[28] =new Tile(0,4,2,4,1,3,display);
  tiles[29] =new Tile(2,4,4,4,3,3,display);
  tiles[30] =new Tile(4,4,6,4,5,3,display);
  tiles[31] =new Tile(6,4,8,4,7,3,display);
  
  
  
  tiles[32] =new Tile(0,4,2,4,1,5,display);
  tiles[33] =new Tile(2,4,4,4,3,5,display);
  tiles[34] =new Tile(4,4,6,4,5,5,display);
  tiles[35] =new Tile(6,4,8,4,7,5,display);
  
  tiles[36] =new Tile(0,4,1,5,0,6,display);
  tiles[37] =new Tile(2,4,3,5,2,6,display);
  tiles[38] =new Tile(4,4,5,5,4,6,display);
  tiles[39] =new Tile(6,4,7,5,6,6,display);
  
  tiles[40] =new Tile(2,4,2,6,1,5,display);
  tiles[41] =new Tile(4,4,4,6,3,5,display);
  tiles[42] =new Tile(6,4,6,6,5,5,display);
  tiles[43] =new Tile(8,4,8,6,7,5,display);
  
  tiles[44] =new Tile(0,6,2,6,1,5,display);
  tiles[45] =new Tile(2,6,4,6,3,5,display);
  tiles[46] =new Tile(4,6,6,6,5,5,display);
  tiles[47] =new Tile(6,6,8,6,7,5,display);
  
  
  
  tiles[48] =new Tile(0,6,2,6,1,7,display);
  tiles[49] =new Tile(2,6,4,6,3,7,display);
  tiles[50] =new Tile(4,6,6,6,5,7,display);
  tiles[51] =new Tile(6,6,8,6,7,7,display);
  
  tiles[52] =new Tile(0,6,1,7,0,8,display);
  tiles[53] =new Tile(2,6,3,7,2,8,display);
  tiles[54] =new Tile(4,6,5,7,4,8,display);
  tiles[55] =new Tile(6,6,7,7,6,8,display);
  
  tiles[56] =new Tile(2,6,2,8,1,7,display);
  tiles[57] =new Tile(4,6,4,8,3,7,display);
  tiles[58] =new Tile(6,6,6,8,5,7,display);
  tiles[59] =new Tile(8,6,8,8,7,7,display);
  
  tiles[60] =new Tile(0,8,2,8,1,7,display);
  tiles[61] =new Tile(2,8,4,8,3,7,display);
  tiles[62] =new Tile(4,8,6,8,5,7,display);
  tiles[63] =new Tile(6,8,8,8,7,7,display);
  
  
  smooth();
  background(255);
  strokeWeight(2);
  strokeJoin(ROUND);
  display=false;
  noStroke();
  fill(25);
  //noLoop();
  //size(600,600); 
  fullScreen();
  
  colorMode(HSB,360,100,100);
  
  randomizeColors();
  
  drawHelp();
}

void draw(){

}

void drawTiles(){
  for(int i=0;i<width;i+=size*8)
  {
    for(int j=0;j<height;j+=size*8)
    {
      for(Tile t:tiles)
      {
         t.disp(i,j);
      }
    }
  }
}

void drawHelp(){
  background(0,0,100);
  fill(100,0,70);
  textSize(24);
  text(help, width/2-180,height/2-200,1000,1000);
  fill(h1,s1,v1);
}

class Tile { 
  float x1, y1, x2, y2, x3, y3;
  boolean visible;
  Tile (float xpos1, float ypos1, float xpos2, float ypos2, float xpos3, float ypos3, boolean v) {  
    x1=xpos1;
    y1=ypos1;
    x2=xpos2;
    y2=ypos2;
    x3=xpos3;
    y3=ypos3;
    visible=v;
  } 
  
  void disp(float x,float y) {
    size=width/(gridSize*8);
    if(visible)triangle(x+size*x1, y+size*y1, x+size*x2, y+size*y2, x+size*x3, y+size*y3);
  }
  
} 

void updateTiles(int[] a){
  for(int i=0;i<64;i++){
    if(a[i]>0)tiles[i].visible=!tiles[i].visible;
  }  
  drawTiles();  
}

int[] createRandom(boolean neigh, boolean symm, int maxSeeds, int chance){
  
  for(int i=0;i<16;i++){
    for(int j=0;j<4;j++){
      sym[i][j]=0;
    } 
  }
  
  int[] randomArray;
  randomArray=new int[64];
  
  int seeds = int(random(1,maxSeeds));
  for(int i=0;i<seeds;i++){
    int randX = int(random(0,16)); 
    int randY = int(random(0,4));
    sym[min(15,randX)][min(3,randY)]=1;
  }
  
  if(neigh)createNeighbours(sym,chance);
  if(symm)createSymmetry(sym);
    
  for(int i=0;i<16;i++){
    for(int j=0;j<4;j++){
      randomArray[4*i+j]=sym[i][j];
    } 
  }  
  
  return randomArray;
}



void createSymmetry(int[][] a){
  for(int i=0;i<16;i++){
    for(int j=0;j<4;j++){
      if(i%4==0){
        if(a[i][j]>0){a[i][3-j]=1;}
      }
      if(i%4==1){
        if(a[i][j]>0){a[i+1][3-j]=1;}
      }
      if(i%4==2){
        if(a[i][j]>0){a[i-1][3-j]=1;}
      }
      if(i%4==3){
        if(a[i][j]>0){a[i][3-j]=1;}
      }
    } 
  }
}

void createNeighbours(int[][] a, int chance){
  for(int i=0;i<16;i++){
    for(int j=0;j<4;j++){
      int t=int(random(0,100));
      if(i%4==0&&t<chance){
        if(a[i][j]>0&&t<chance){a[(i+15)%16][j]=1;}
      }
      if(i%4==1&&t<chance){
        if(a[i][j]>0){a[i+1][(j+3)%4]=1;}
      }
      if(i%4==2&&t<chance){
        if(a[i][j]>0){a[i-1][(j+5)%4]=1;}
      }
      if(i%4==3&&t<chance){
        if(a[i][j]>0){a[(i+17)%16][j]=1;}
      }
    } 
  }
}

void randomizeColors(){
  
  float mono=random(0,10);
  
  h1=int(random(0,361))%360;
  s1=int(random(50,101));
  v1=int(random(30,70));
  s1=s1-(v1-15);
  
  if(mono<1.5)s1=0;
  
  fill(h1,s1,v1);
  stroke(h1,s1,v1);
  
  int side=0;
  coinFlip=random(-1,1);
  if(coinFlip<0){side=-1;}else{side=1;}  
  
  hbg=h1+int(random(-10,10));
  sbg=s1;
  vbg=v1+side*int(random(10,25));
  
  background(hbg,sbg,vbg);
  if(vbg<10)randomizeColors();
}


void keyPressed(){
  
  if(keyCode<=90&&keyCode>=65||keyCode==ENTER||keyCode==BACKSPACE||
     keyCode==TAB||key==' '||keyCode==LEFT||keyCode==RIGHT)
     background(hbg,sbg,vbg);
  
  if(key=='a'||key=='A'){
    updateTiles(keyA);
  }
  if(key=='b'||key=='B'){
    updateTiles(keyB);
  }
  if(key=='c'||key=='C'){
    updateTiles(keyC);
  }  
  if(key=='d'||key=='D'){
    updateTiles(keyD);
  }  
  if(key=='e'||key=='E'){
    updateTiles(keyE);
  }  
  if(key=='f'||key=='F'){
    updateTiles(keyF);
  }  
  if(key=='g'||key=='G'){
    updateTiles(keyG);
  }  
  if(key=='h'||key=='H'){
    updateTiles(keyH);
  }  
  if(key=='i'||key=='I'){
    updateTiles(keyI);
  }  
  if(key=='j'||key=='J'){
    updateTiles(keyJ);
  }  
  if(key=='k'||key=='K'){
    updateTiles(keyK);
  }  
  if(key=='l'||key=='L'){
    updateTiles(keyL);
  }  
  if(key=='m'||key=='M'){
    updateTiles(keyM);
  }  
  if(key=='n'||key=='N'){
    updateTiles(keyN);
  }  
  if(key=='o'||key=='O'){
    updateTiles(keyO);
  }  
  if(key=='p'||key=='P'){
    updateTiles(keyP);
  }  
  if(key=='q'||key=='Q'){
    updateTiles(keyQ);
  }
  if(key=='r'||key=='R'){
    updateTiles(keyR);
  }
  if(key=='s'||key=='S'){
    updateTiles(keyS);
  }
  if(key=='t'||key=='T'){
    updateTiles(keyT);
  }
  if(key=='u'||key=='U'){
    updateTiles(keyU);
  }
  if(key=='v'||key=='V'){
    updateTiles(keyV);
  }
  if(key=='w'||key=='W'){
    updateTiles(keyW);
  }
  if(key=='x'||key=='X'){
    updateTiles(keyX);
  }
  if(key=='y'||key=='Y'){
    updateTiles(keyY);
  }
  if(key=='z'||key=='Z'){
    updateTiles(keyZ);
  }
  if(key==ENTER){    
    for(Tile t:tiles){
      t.visible=false;
    }
    randomizeColors();
    updateTiles(createRandom(true,true,33,75));
  }
  if(keyCode==BACKSPACE){
    for(Tile t:tiles){
      t.visible=false;
    }
    drawHelp();
  }
  
  if(key==' '){    
    randomizeColors();
    drawTiles();
  }
  
  if(keyCode==CONTROL||keyCode==157){ //OSX Cmd key
    for(int i=0;i<64;i++){
      save[i]=tiles[i].visible;
      h1s=h1;
      s1s=s1;
      v1s=v1;
      hbgs=hbg;
      sbgs=sbg;
      vbgs=vbg;
    }
    saveExists=true;
  }
  if(keyCode==TAB&&saveExists){
    for(int i=0;i<64;i++){
      tiles[i].visible=save[i];
    }
    fill(h1s,s1s,v1s);
    stroke(h1s,s1s,v1s);
    
    hbg=hbgs;
    sbg=sbgs;
    vbg=vbgs;
    
    background(hbg,sbg,vbg);
    
    drawTiles();
  }
  if(keyCode==LEFT){
    if(gridSize>1)gridSize--;
    drawTiles();
  }
  if(keyCode==RIGHT){
    if(gridSize<26)gridSize++;
    drawTiles();
  }
  if(keyCode==SHIFT){
  saveFrame("###.png");
  }
}